#

API Docs for: v2.11.1
Show: Inherited Protected Private Deprecated

# Ember.AutoLocation Class

Defined in: `packages/ember-routing/lib/location/auto_location.js:22`
Module: ember-routing
Parent Module: ember

Ember.AutoLocation will select the best location option based off browser support with the priority order: history, hash, none.

Clean pushState paths accessed by hashchange-only browsers will be redirected to the hash-equivalent and vice versa so future transitions are consistent.

Keep in mind that since some of your users will use `HistoryLocation`, your server must serve the Ember app at all the routes you define.

- Index
- Methods
- Properties

## Item Index

### Methods

- _getHashPath

### Properties

- cancelRouterSetup
- global
- history
- location
- rootURL
- userAgent

## Methods

### `_getHashPath`

() private

Defined in `packages/ember-routing/lib/location/auto_location.js:275`

## Properties

### `cancelRouterSetup`

Unknown private

Defined in `packages/ember-routing/lib/location/auto_location.js:84`

Available since 1.5.1

Default: false

### `global`

Unknown private

Defined in `packages/ember-routing/lib/location/auto_location.js:61`

Available since 1.11

Default: window

### `history`

Unknown private

Defined in `packages/ember-routing/lib/location/auto_location.js:49`

Available since 1.5.1

Default: environment.history

### `location`

Unknown private

Defined in `packages/ember-routing/lib/location/auto_location.js:38`

Default: environment.location

### `rootURL`

Unknown private

Defined in `packages/ember-routing/lib/location/auto_location.js:96`

Available since 1.5.1

Default: '/'

### `userAgent`

Unknown private

Defined in `packages/ember-routing/lib/location/auto_location.js:72`

Available since 1.5.1

Default: environment.history